#include "Lasers.h"

VL53L1X sensors[nbrLasers];

///   I2C ADDRESS    ///

const uint8_t AddressI2CSensors[4] = {0x2D,0x2C,0x2B,0x2A};

///   PINS RESET SENSORS    ///
const uint8_t sensorsResetPins[4] = {5,18,23,32};

void initLaserSensors(void)
{
  pinMode(sensorsResetPins[0], OUTPUT);
  pinMode(sensorsResetPins[1], OUTPUT);
  pinMode(sensorsResetPins[2], OUTPUT);
  pinMode(sensorsResetPins[3], OUTPUT);

  digitalWrite(sensorsResetPins[0], LOW);
  digitalWrite(sensorsResetPins[1], LOW);
  digitalWrite(sensorsResetPins[2], LOW);
  digitalWrite(sensorsResetPins[3], LOW);

  Serial.println();
 
  for(int8_t i = 0; i<nbrLasers;i++)
  {
    digitalWrite(sensorsResetPins[i], HIGH);
    delay(100);
    sensors[i].setTimeout(500);
    if (!sensors[i].init())
    {
      Serial.print("Failed to detect and initialize sensor: ");Serial.println(i, DEC);
      while (1);
    }
    changeAddress(i, AddressI2CSensors[i]);
    sensors[i].startContinuous(50);
    Serial.print("VL53L1X ");Serial.print(i, DEC);Serial.println(" initialized");
    delay(100);
  }
}

void sensorRead(uint16_t* measure, uint8_t sensor_Id)
{
  *measure = sensors[sensor_Id].read();
  //if (sensor->timeoutOccurred()) { Serial.print(" TIMEOUT"); }
}

void changeAddress(uint8_t sensor_Id, uint8_t address)
{
  sensors[sensor_Id].setAddress(0x29);
  sensors[sensor_Id].setAddress(address);
}

void tick_Lasers(uint16_t* measures)
{
  for(uint8_t i =0;i<nbrLasers;i++)
  {
    sensorRead(&measures[i], i);
    Serial.print("Mesure laser ");Serial.print(i,DEC);Serial.print(" : ");Serial.println(measures[i],DEC);
  }
    

  
}
