#include "Communication.h"

void scanI2C(void)
{
  byte error, address;
  int nDevices;
  Serial.println("\nI2C Scanner");
  Serial.println("Scanning...");
  nDevices = 0;
  for(address = 1; address < 127; address++ ) {
    Wire.beginTransmission(address);
    error = Wire.endTransmission();
    if (error == 0) {
      Serial.print("I2C device found at address 0x");
      if (address<16) {
        Serial.print("0");
      }
      Serial.println(address,HEX);
      nDevices++;
    }
    else if (error==4) {
      Serial.print("Unknow error at address 0x");
      if (address<16) {
        Serial.print("0");
      }
      Serial.println(address,HEX);
    }    
  }
  if (nDevices == 0) {
    Serial.println("No I2C devices found\n");
  }
  else {
    Serial.println("done\n");
  }  
}

void initI2CBus(void)
{
  Wire.begin();
  Wire.setClock(400000);
  
}

void initSerialBus(void)
{
  Serial.begin(115200);
}
